HDU5542(dp + 树状数组)

来源:互联网 发布:3钻淘宝店铺卖多少钱 编辑:程序博客网 时间:2024/05/18 18:53

The Battle of Chibi

Time Limit: 6000/4000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 1905    Accepted Submission(s): 669


Problem Description
Cao Cao made up a big army and was going to invade the whole South China. Yu Zhou was worried about it. He thought the only way to beat Cao Cao is to have a spy in Cao Cao's army. But all generals and soldiers of Cao Cao were loyal, it's impossible to convince any of them to betray Cao Cao.

So there is only one way left for Yu Zhou, send someone to fake surrender Cao Cao. Gai Huang was selected for this important mission. However, Cao Cao was not easy to believe others, so Gai Huang must leak some important information to Cao Cao before surrendering.

Yu Zhou discussed with Gai Huang and worked out N information to be leaked, in happening order. Each of the information was estimated to has ai value in Cao Cao's opinion.

Actually, if you leak information with strict increasing value could accelerate making Cao Cao believe you. So Gai Huang decided to leak exact M information with strict increasing value in happening order. In other words, Gai Huang will not change the order of the N information and just select M of them. Find out how many ways Gai Huang could do this.
 

Input
The first line of the input gives the number of test cases, T(1100)T test cases follow.

Each test case begins with two numbers N(1N103) and M(1MN), indicating the number of information and number of information Gai Huang will select. Then N numbers in a line, the ith number ai(1ai109) indicates the value in Cao Cao's opinion of the ith information in happening order.
 

Output
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the ways Gai Huang can select the information.

The result is too large, and you need to output the result mod by 1000000007(109+7).
 

Sample Input
23 21 2 33 23 2 1
 

Sample Output
Case #1: 3Case #2: 0
Hint
In the first cases, Gai Huang need to leak 2 information out of 3. He could leak any 2 information as all the information value are in increasing order. In the second cases, Gai Huang has no choice as selecting any 2 information is not in increasing order.
 

Source
The 2015 China Collegiate Programming Contest

解题思路:dp[i][j]表示考虑到第i个数,且以第a[i]个数结尾,长度为j的递增序列个数,显然dp[i][j] = sum(dp[k][j - 1]) a[i] > a[k],直接求解需要O(n * n * n),显然不可行,我们把数值离散化一下,然后用树状数组维护前缀和就行。

#include <bits/stdc++.h>using namespace std;const int maxn = 1000 + 10;typedef long long LL;const LL mod = 1e9 + 7;int N, M;int a[maxn];LL Tree[maxn][maxn];LL dp[maxn][maxn];//dp[i][j]表示考虑到第i个数,且以第a[i]个数结尾,长度为j的递增序列个数struct node{    int value;    int id;    bool operator <(const node &res) const{        if(value == res.value) return id > res.id;        else return value < res.value;    }}Node[maxn];int Rank[maxn];void init(){    memset(Tree, 0, sizeof(Tree));    memset(dp, 0, sizeof(dp));}int lowbit(int x){    return x&(-x);}void add(int loc, int d, LL value){    for(int i = loc; i <= N; i += lowbit(i))    {        Tree[i][d] = (Tree[i][d] + value) % mod;    }}LL get(int loc, int d){    LL ans = 0;    for(int i = loc; i >= 1; i -= lowbit(i))    {        ans = (ans + Tree[i][d]) % mod;    }    return ans;}int main(){    int T;    scanf("%d", &T);    int Case = 1;    while(T--)    {        scanf("%d%d", &N, &M);        init();        for(int i = 1; i <= N; i++)        {            scanf("%d", &Node[i].value);            Node[i].id = i;        }        sort(Node + 1, Node + N + 1);        for(int i = 1; i <= N; i++)        {            Rank[Node[i].id] = i;        }        for(int i = 1; i <= N; i++)        {            dp[i][1] = 1;            add(Rank[i], 1, 1);            for(int j = 2; j <= min(M, i); j++)            {                LL temp = get(Rank[i] - 1, j - 1);                dp[i][j] = (dp[i][j] + temp) % mod;                add(Rank[i], j, dp[i][j]);            }        }        LL ans = 0;        for(int i = 1; i <= N; i++)        {            ans = (ans + dp[i][M]) % mod;        }        printf("Case #%d: %lld\n", Case++, ans);    }    return 0;}